javax.persistence

## Enum InheritanceType

- java.lang.Object
- - java.lang.Enum<InheritanceType>
  - - javax.persistence.InheritanceType

All Implemented Interfaces:
  java.io.Serializable, java.lang.Comparable<InheritanceType>

    public enum InheritanceType
    extends java.lang.Enum<InheritanceType>

Defines inheritance strategy options.

Since:
  Java Persistence 1.0

### Enum Constant Summary

Enum Constants
Enum Constant and Description
`JOINED` A strategy in which fields that are specific to a subclass are mapped to a separate table than the fields that are common to the parent class, and a join is performed to instantiate the subclass.
`SINGLE_TABLE` A single table per class hierarchy.
`TABLE_PER_CLASS` A table per concrete entity class.

### Method Summary

All Methods Static Methods Concrete Methods
`static InheritanceType` `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
`static InheritanceType[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### SINGLE_TABLE

    public static final InheritanceType SINGLE_TABLE

A single table per class hierarchy.

#### TABLE_PER_CLASS

    public static final InheritanceType TABLE_PER_CLASS

A table per concrete entity class.

#### JOINED

    public static final InheritanceType JOINED

A strategy in which fields that are specific to a subclass are mapped to a separate table than the fields that are common to the parent class, and a join is performed to instantiate the subclass.

### Method Detail

#### values

    public static InheritanceType[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (InheritanceType c : InheritanceType.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static InheritanceType valueOf(java.lang.String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
  `java.lang.NullPointerException` - if the argument is null